diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wave/helper/wave-helper.cc ns-3.34/src/wave/helper/wave-helper.cc
--- ns-3.33/src/wave/helper/wave-helper.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/wave/helper/wave-helper.cc	2021-07-14 10:31:07.000000000 -0700
@@ -26,7 +26,6 @@
 #include "ns3/minstrel-wifi-manager.h"
 #include "ns3/radiotap-header.h"
 #include "ns3/unused.h"
-#include "ns3/wifi-ack-policy-selector.h"
 #include "wave-mac-helper.h"
 #include "wave-helper.h"
 
@@ -278,10 +277,6 @@
                                   "DataMode", StringValue ("OfdmRate6MbpsBW10MHz"),
                                   "ControlMode",StringValue ("OfdmRate6MbpsBW10MHz"),
                                   "NonUnicastMode", StringValue ("OfdmRate6MbpsBW10MHz"));
-  helper.SetAckPolicySelectorForAc (AC_BE, "ns3::ConstantWifiAckPolicySelector");
-  helper.SetAckPolicySelectorForAc (AC_BK, "ns3::ConstantWifiAckPolicySelector");
-  helper.SetAckPolicySelectorForAc (AC_VI, "ns3::ConstantWifiAckPolicySelector");
-  helper.SetAckPolicySelectorForAc (AC_VO, "ns3::ConstantWifiAckPolicySelector");
   return helper;
 }
 
@@ -340,29 +335,6 @@
 }
 
 void
-WaveHelper::SetAckPolicySelectorForAc (AcIndex ac, std::string type,
-                                       std::string n0, const AttributeValue &v0,
-                                       std::string n1, const AttributeValue &v1,
-                                       std::string n2, const AttributeValue &v2,
-                                       std::string n3, const AttributeValue &v3,
-                                       std::string n4, const AttributeValue &v4,
-                                       std::string n5, const AttributeValue &v5,
-                                       std::string n6, const AttributeValue &v6,
-                                       std::string n7, const AttributeValue &v7)
-{
-  m_ackPolicySelector[ac] = ObjectFactory ();
-  m_ackPolicySelector[ac].SetTypeId (type);
-  m_ackPolicySelector[ac].Set (n0, v0);
-  m_ackPolicySelector[ac].Set (n1, v1);
-  m_ackPolicySelector[ac].Set (n2, v2);
-  m_ackPolicySelector[ac].Set (n3, v3);
-  m_ackPolicySelector[ac].Set (n4, v4);
-  m_ackPolicySelector[ac].Set (n5, v5);
-  m_ackPolicySelector[ac].Set (n6, v6);
-  m_ackPolicySelector[ac].Set (n7, v7);
-}
-
-void
 WaveHelper::SetChannelScheduler (std::string type,
                                  std::string n0, const AttributeValue &v0,
                                  std::string n1, const AttributeValue &v1,
@@ -420,40 +392,10 @@
       for (std::vector<uint32_t>::const_iterator k = m_macsForChannelNumber.begin ();
            k != m_macsForChannelNumber.end (); ++k)
         {
-          Ptr<WifiMac> wifiMac = macHelper.Create (device);
+          Ptr<WifiMac> wifiMac = macHelper.Create (device, WIFI_STANDARD_80211p);
           Ptr<OcbWifiMac> ocbMac = DynamicCast<OcbWifiMac> (wifiMac);
-          // we use WaveMacLow to replace original MacLow
-          ocbMac->EnableForWave (device);
           ocbMac->SetWifiRemoteStationManager (m_stationManager.Create<WifiRemoteStationManager> ());
-          ocbMac->ConfigureStandard (WIFI_STANDARD_80211p);
-          // Install ack policy selector
-          BooleanValue qosSupported;
-          PointerValue ptr;
-          Ptr<WifiAckPolicySelector> ackSelector;
-
-          ocbMac->GetAttributeFailSafe ("QosSupported", qosSupported);
-          if (qosSupported.Get ())
-            {
-              ocbMac->GetAttributeFailSafe ("BE_Txop", ptr);
-              ackSelector = m_ackPolicySelector[AC_BE].Create<WifiAckPolicySelector> ();
-              ackSelector->SetQosTxop (ptr.Get<QosTxop> ());
-              ptr.Get<QosTxop> ()->SetAckPolicySelector (ackSelector);
-
-              ocbMac->GetAttributeFailSafe ("BK_Txop", ptr);
-              ackSelector = m_ackPolicySelector[AC_BK].Create<WifiAckPolicySelector> ();
-              ackSelector->SetQosTxop (ptr.Get<QosTxop> ());
-              ptr.Get<QosTxop> ()->SetAckPolicySelector (ackSelector);
-
-              ocbMac->GetAttributeFailSafe ("VI_Txop", ptr);
-              ackSelector = m_ackPolicySelector[AC_VI].Create<WifiAckPolicySelector> ();
-              ackSelector->SetQosTxop (ptr.Get<QosTxop> ());
-              ptr.Get<QosTxop> ()->SetAckPolicySelector (ackSelector);
-
-              ocbMac->GetAttributeFailSafe ("VO_Txop", ptr);
-              ackSelector = m_ackPolicySelector[AC_VO].Create<WifiAckPolicySelector> ();
-              ackSelector->SetQosTxop (ptr.Get<QosTxop> ());
-              ptr.Get<QosTxop> ()->SetAckPolicySelector (ackSelector);
-            }
+          ocbMac->EnableForWave (device);
           device->AddMac (*k, ocbMac);
         }
 
@@ -491,7 +433,7 @@
   LogComponentEnable ("VsaManager", LOG_LEVEL_ALL);
   LogComponentEnable ("OcbWifiMac", LOG_LEVEL_ALL);
   LogComponentEnable ("VendorSpecificAction", LOG_LEVEL_ALL);
-  LogComponentEnable ("WaveMacLow", LOG_LEVEL_ALL);
+  LogComponentEnable ("WaveFrameExchangeManager", LOG_LEVEL_ALL);
   LogComponentEnable ("HigherLayerTxVectorTag", LOG_LEVEL_ALL);
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wave/helper/wave-helper.h ns-3.34/src/wave/helper/wave-helper.h
--- ns-3.33/src/wave/helper/wave-helper.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/wave/helper/wave-helper.h	2021-07-14 10:31:07.000000000 -0700
@@ -42,6 +42,7 @@
 public:
   /**
    * Create a phy helper in a default working state.
+   * \return A phy helper
    */
   static YansWavePhyHelper Default (void);
 
@@ -166,38 +167,6 @@
                                 std::string n6 = "", const AttributeValue &v6 = EmptyAttributeValue (),
                                 std::string n7 = "", const AttributeValue &v7 = EmptyAttributeValue ());
   /**
-   * \param ac the Access Category to attach the ack policy selector to.
-   * \param type the type of ns3::WifiAckPolicySelector to create.
-   * \param n0 the name of the attribute to set
-   * \param v0 the value of the attribute to set
-   * \param n1 the name of the attribute to set
-   * \param v1 the value of the attribute to set
-   * \param n2 the name of the attribute to set
-   * \param v2 the value of the attribute to set
-   * \param n3 the name of the attribute to set
-   * \param v3 the value of the attribute to set
-   * \param n4 the name of the attribute to set
-   * \param v4 the value of the attribute to set
-   * \param n5 the name of the attribute to set
-   * \param v5 the value of the attribute to set
-   * \param n6 the name of the attribute to set
-   * \param v6 the value of the attribute to set
-   * \param n7 the name of the attribute to set
-   * \param v7 the value of the attribute to set
-   *
-   * All the attributes specified in this method should exist
-   * in the requested ack policy selector.
-   */
-  void SetAckPolicySelectorForAc (AcIndex ac, std::string type,
-                                  std::string n0 = "", const AttributeValue &v0 = EmptyAttributeValue (),
-                                  std::string n1 = "", const AttributeValue &v1 = EmptyAttributeValue (),
-                                  std::string n2 = "", const AttributeValue &v2 = EmptyAttributeValue (),
-                                  std::string n3 = "", const AttributeValue &v3 = EmptyAttributeValue (),
-                                  std::string n4 = "", const AttributeValue &v4 = EmptyAttributeValue (),
-                                  std::string n5 = "", const AttributeValue &v5 = EmptyAttributeValue (),
-                                  std::string n6 = "", const AttributeValue &v6 = EmptyAttributeValue (),
-                                  std::string n7 = "", const AttributeValue &v7 = EmptyAttributeValue ());
-  /**
    * \param type the type of ns3::ChannelScheduler to create.
    * \param n0 the name of the attribute to set
    * \param v0 the value of the attribute to set
@@ -277,7 +246,6 @@
 
 protected:
   ObjectFactory m_stationManager; ///< station manager
-  ObjectFactory m_ackPolicySelector[4]; ///< ack policy selector for all ACs
   ObjectFactory m_channelScheduler; ///< channel scheduler
   std::vector<uint32_t> m_macsForChannelNumber; ///< MACs for channel number
   uint32_t m_physNumber; ///< Phy number
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wave/helper/wave-mac-helper.h ns-3.34/src/wave/helper/wave-mac-helper.h
--- ns-3.33/src/wave/helper/wave-mac-helper.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/wave/helper/wave-mac-helper.h	2021-07-14 10:31:07.000000000 -0700
@@ -115,6 +115,7 @@
 
   /**
    * Create a mac helper in a default working state.
+   * \return A mac helper
    */
   static QosWaveMacHelper Default (void);
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wave/model/bsm-application.h ns-3.34/src/wave/model/bsm-application.h
--- ns-3.33/src/wave/model/bsm-application.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/wave/model/bsm-application.h	2021-07-14 10:31:07.000000000 -0700
@@ -48,7 +48,6 @@
 
   /**
    * \brief Constructor
-   * \return none
    */
   BsmApplication ();
   virtual ~BsmApplication ();
@@ -70,7 +69,6 @@
    * \param nodesMoving of whether or not node(s) are moving
    * \param mode
    * \param txDelay
-   * \return none
    */
   void Setup (Ipv4InterfaceContainer & i,
               int nodeId,
@@ -116,7 +114,6 @@
    * \param pktInterval the interval, in seconds, until the next packet
    * should be transmitted
    * \param sendingNodeId
-   * \return none
    */
   void GenerateWaveTraffic (Ptr<Socket> socket, uint32_t pktSize,
                             uint32_t pktCount, Time pktInterval,
@@ -125,7 +122,6 @@
   /**
    * \brief Receive a WAVE BSM packet
    * \param socket the receiving socket
-   * \return none
    */
   void ReceiveWavePacket (Ptr<Socket> socket);
 
@@ -133,7 +129,6 @@
    * \brief Handle the receipt of a WAVE BSM packet from sender to receiver
    * \param txNode the sending node
    * \param rxNode the receiving node
-   * \return none
    */
   void HandleReceivedBsmPacket (Ptr<Node> txNode,
                                 Ptr<Node> rxNode);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wave/model/channel-manager.cc ns-3.34/src/wave/model/channel-manager.cc
--- ns-3.33/src/wave/model/channel-manager.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/wave/model/channel-manager.cc	2021-07-14 10:31:07.000000000 -0700
@@ -51,12 +51,6 @@
 ChannelManager::~ChannelManager ()
 {
   NS_LOG_FUNCTION (this);
-  std::map<uint32_t, WaveChannel *> ::iterator i;
-  for (i = m_channels.begin (); i != m_channels.end (); ++i)
-    {
-      delete (i->second);
-    }
-  m_channels.clear ();
 }
 
 uint32_t
@@ -175,4 +169,16 @@
   return m_channels[channelNumber]->txPowerLevel;
 }
 
+void
+ChannelManager::DoDispose (void)
+{
+  NS_LOG_FUNCTION (this);
+  std::map<uint32_t, WaveChannel *> ::iterator i;
+  for (i = m_channels.begin (); i != m_channels.end (); ++i)
+    {
+      delete (i->second);
+    }
+  m_channels.clear ();
+}
+
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wave/model/channel-manager.h ns-3.34/src/wave/model/channel-manager.h
--- ns-3.33/src/wave/model/channel-manager.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/wave/model/channel-manager.h	2021-07-14 10:31:07.000000000 -0700
@@ -21,7 +21,7 @@
 #include <vector>
 #include "ns3/object.h"
 #include "ns3/wifi-mode.h"
-#include "ns3/wifi-preamble.h"
+#include "ns3/wifi-phy-common.h"
 
 namespace ns3 {
 
@@ -132,6 +132,9 @@
    */
   uint32_t GetManagementPowerLevel (uint32_t channelNumber);
 
+protected:
+  virtual void DoDispose (void);
+
 private:
   /// 1609.4-2010 Annex H
   static const uint32_t  DEFAULT_OPERATING_CLASS = 17;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wave/model/channel-scheduler.cc ns-3.34/src/wave/model/channel-scheduler.cc
--- ns-3.33/src/wave/model/channel-scheduler.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/wave/model/channel-scheduler.cc	2021-07-14 10:31:07.000000000 -0700
@@ -160,4 +160,11 @@
   return ReleaseAccess (channelNumber);
 }
 
+void
+ChannelScheduler::DoDispose (void)
+{
+  NS_LOG_FUNCTION (this);
+  m_device = 0;
+}
+
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wave/model/channel-scheduler.h ns-3.34/src/wave/model/channel-scheduler.h
--- ns-3.33/src/wave/model/channel-scheduler.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/wave/model/channel-scheduler.h	2021-07-14 10:31:07.000000000 -0700
@@ -195,6 +195,7 @@
 
 protected:
   virtual void DoInitialize (void);
+  virtual void DoDispose (void);
 
   /**
      * \param channelNumber the specific channel
@@ -214,6 +215,7 @@
   virtual bool AssignContinuousAccess (uint32_t channelNumber, bool immediate) = 0;
   /**
    * \param channelNumber the specific channel
+   * \param extends extension duration
    * \param immediate indicate whether channel switch to channel
    * \return whether the channel access is assigned successfully
    *
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wave/model/default-channel-scheduler.cc ns-3.34/src/wave/model/default-channel-scheduler.cc
--- ns-3.33/src/wave/model/default-channel-scheduler.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/wave/model/default-channel-scheduler.cc	2021-07-14 10:31:07.000000000 -0700
@@ -111,6 +111,7 @@
     {
       m_waitEvent.Cancel ();
     }
+  m_phy = 0;
   ChannelScheduler::DoDispose ();
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wave/model/default-channel-scheduler.h ns-3.34/src/wave/model/default-channel-scheduler.h
--- ns-3.33/src/wave/model/default-channel-scheduler.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/wave/model/default-channel-scheduler.h	2021-07-14 10:31:07.000000000 -0700
@@ -87,6 +87,7 @@
   virtual bool AssignContinuousAccess (uint32_t channelNumber, bool immediate);
   /**
    * \param channelNumber the specific channel
+   * \param extends extension duration
    * \param immediate indicate whether channel switch to channel
    * \return whether the channel access is assigned successfully
    *
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wave/model/ocb-wifi-mac.cc ns-3.34/src/wave/model/ocb-wifi-mac.cc
--- ns-3.33/src/wave/model/ocb-wifi-mac.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/wave/model/ocb-wifi-mac.cc	2021-07-14 10:31:07.000000000 -0700
@@ -27,7 +27,8 @@
 #include "ns3/mac-rx-middle.h"
 #include "ns3/ht-capabilities.h"
 #include "ns3/vht-capabilities.h"
-#include "wave-mac-low.h"
+#include "ns3/channel-access-manager.h"
+#include "wave-frame-exchange-manager.h"
 #include "ocb-wifi-mac.h"
 #include "vendor-specific-action.h"
 #include "higher-tx-tag.h"
@@ -390,6 +391,21 @@
   ConfigureEdca (cwmin, cwmax, 3, AC_VI);
   ConfigureEdca (cwmin, cwmax, 6, AC_BE);
   ConfigureEdca (cwmin, cwmax, 9, AC_BK);
+
+  // Setup FrameExchangeManager
+  m_feManager = CreateObject<WaveFrameExchangeManager> ();
+  m_feManager->SetWifiMac (this);
+  m_feManager->SetMacTxMiddle (m_txMiddle);
+  m_feManager->SetMacRxMiddle (m_rxMiddle);
+  m_feManager->SetAddress (GetAddress ());
+  m_channelAccessManager->SetupFrameExchangeManager (m_feManager);
+  if (GetQosSupported ())
+    {
+      for (const auto& pair : m_edca)
+        {
+          pair.second->SetQosFrameExchangeManager (DynamicCast<QosFrameExchangeManager> (m_feManager));
+        }
+    }
 }
 
 
@@ -398,7 +414,7 @@
 {
   NS_LOG_FUNCTION (this);
   m_channelAccessManager->NotifySleepNow ();
-  m_low->NotifySleepNow ();
+  m_feManager->NotifySleepNow ();
 }
 
 void
@@ -432,23 +448,22 @@
   NS_LOG_FUNCTION (this);
   // The switching event is used to notify MAC entity reset its operation.
   m_channelAccessManager->NotifySwitchingStartNow (Time (0));
-  m_low->NotifySwitchingStartNow (Time (0));
+  m_feManager->NotifySwitchingStartNow (Time (0));
 }
 
 void
 OcbWifiMac::EnableForWave (Ptr<WaveNetDevice> device)
 {
   NS_LOG_FUNCTION (this << device);
-  // To extend current OcbWifiMac for WAVE 1609.4, we shall use WaveMacLow instead of MacLow
-  m_low = CreateObject<WaveMacLow> ();
-  (DynamicCast<WaveMacLow> (m_low))->SetWaveNetDevice (device);
-  m_low->SetRxCallback (MakeCallback (&MacRxMiddle::Receive, m_rxMiddle));
-  m_channelAccessManager->SetupLow (m_low);
-  m_txop->SetMacLow (m_low);
-  for (EdcaQueues::iterator i = m_edca.begin (); i != m_edca.end (); ++i)
-    {
-      i->second->SetMacLow (m_low);
-      i->second->CompleteConfig ();
-    }
+  // To extend current OcbWifiMac for WAVE 1609.4, we shall use WaveFrameExchangeManager
+  StaticCast<WaveFrameExchangeManager> (m_feManager)->SetWaveNetDevice (device);
 }
+
+void
+OcbWifiMac::DoDispose (void)
+{
+  NS_LOG_FUNCTION (this);
+  RegularWifiMac::DoDispose ();
+}
+
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wave/model/ocb-wifi-mac.h ns-3.34/src/wave/model/ocb-wifi-mac.h
--- ns-3.33/src/wave/model/ocb-wifi-mac.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/wave/model/ocb-wifi-mac.h	2021-07-14 10:31:07.000000000 -0700
@@ -101,6 +101,7 @@
   /**
    * This method shall not be used in WAVE environment and
    * here it will overloaded to log warn message
+   * \return An invalid BSSID.
    */
   virtual Mac48Address GetBssid (void) const;
   /**
@@ -175,6 +176,8 @@
 
   // Inherited from base class
   virtual void ConfigureStandard (enum WifiStandard standard);
+protected:
+  virtual void DoDispose (void);
 private:
   virtual void Receive (Ptr<WifiMacQueueItem> mpdu);
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wave/model/vendor-specific-action.h ns-3.34/src/wave/model/vendor-specific-action.h
--- ns-3.33/src/wave/model/vendor-specific-action.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/wave/model/vendor-specific-action.h	2021-07-14 10:31:07.000000000 -0700
@@ -61,7 +61,11 @@
    * \param length identifier length
    */
   OrganizationIdentifier (const uint8_t *str, uint32_t length);
-  /// assignment operator
+  /**
+   * Assignment operator
+   * \param oi object to copy from
+   * \return reference to the new object
+   */
   OrganizationIdentifier& operator= (const OrganizationIdentifier& oi);
   virtual ~OrganizationIdentifier (void);
 
@@ -167,7 +171,11 @@
    */
   OrganizationIdentifier GetOrganizationIdentifier (void) const;
   /**
-   * the category field shall be CATEGORY_OF_VSA
+   * Get the category field
+   *
+   * The category field shall be CATEGORY_OF_VSA
+   *
+   * \return The category field
    */
   uint8_t GetCategory (void) const;
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wave/model/vsa-manager.h ns-3.34/src/wave/model/vsa-manager.h
--- ns-3.33/src/wave/model/vsa-manager.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/wave/model/vsa-manager.h	2021-07-14 10:31:07.000000000 -0700
@@ -132,7 +132,10 @@
    */
   void SetWaveNetDevice (Ptr<WaveNetDevice> device);
 
-  /// set wave vsa callback function
+  /**
+   * Set wave vsa callback function
+   * \param vsaCallback the callback
+   */
   void SetWaveVsaCallback (Callback<bool, Ptr<const Packet>,const Address &, uint32_t, uint32_t>  vsaCallback);
 
   /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wave/model/wave-frame-exchange-manager.cc ns-3.34/src/wave/model/wave-frame-exchange-manager.cc
--- ns-3.33/src/wave/model/wave-frame-exchange-manager.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.34/src/wave/model/wave-frame-exchange-manager.cc	2021-07-14 10:31:07.000000000 -0700
@@ -0,0 +1,175 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2020 Universita' degli Studi di Napoli Federico II
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Stefano Avallone <stavallo@unina.it>
+ */
+
+#include "ns3/log.h"
+#include "ns3/abort.h"
+#include "ns3/wifi-protection.h"
+#include "ns3/wifi-acknowledgment.h"
+#include "wave-frame-exchange-manager.h"
+#include "higher-tx-tag.h"
+
+
+namespace ns3 {
+
+NS_LOG_COMPONENT_DEFINE ("WaveFrameExchangeManager");
+
+NS_OBJECT_ENSURE_REGISTERED (WaveFrameExchangeManager);
+
+TypeId
+WaveFrameExchangeManager::GetTypeId (void)
+{
+  static TypeId tid = TypeId ("ns3::WaveFrameExchangeManager")
+    .SetParent<QosFrameExchangeManager> ()
+    .AddConstructor<WaveFrameExchangeManager> ()
+    .SetGroupName ("Wave")
+  ;
+  return tid;
+}
+
+WaveFrameExchangeManager::WaveFrameExchangeManager ()
+{
+  NS_LOG_FUNCTION (this);
+}
+
+WaveFrameExchangeManager::~WaveFrameExchangeManager ()
+{
+  NS_LOG_FUNCTION_NOARGS ();
+}
+
+void
+WaveFrameExchangeManager::SetWaveNetDevice (Ptr<WaveNetDevice> device)
+{
+  m_scheduler = device->GetChannelScheduler ();
+  m_coordinator = device->GetChannelCoordinator ();
+  NS_ASSERT (m_scheduler != 0 && m_coordinator != 0);
+}
+
+WifiTxVector
+WaveFrameExchangeManager::GetDataTxVector (Ptr<const WifiMacQueueItem> item) const
+{
+  NS_LOG_FUNCTION (this << *item);
+  HigherLayerTxVectorTag datatag;
+  bool found;
+  found = ConstCast<Packet> (item->GetPacket ())->PeekPacketTag (datatag);
+  // if high layer has not controlled transmit parameters, the real transmit parameters
+  // will be determined by MAC layer itself.
+  if (!found)
+    {
+      return m_mac->GetWifiRemoteStationManager ()->GetDataTxVector (item->GetHeader ());
+    }
+
+  // if high layer has set the transmit parameters with non-adaption mode,
+  // the real transmit parameters are determined by high layer.
+  if (!datatag.IsAdaptable ())
+    {
+      return datatag.GetTxVector ();
+    }
+
+  // if high layer has set the transmit parameters with non-adaption mode,
+  // the real transmit parameters are determined by both high layer and MAC layer.
+  WifiTxVector txHigher = datatag.GetTxVector ();
+  WifiTxVector txMac = m_mac->GetWifiRemoteStationManager ()->GetDataTxVector (item->GetHeader ());
+  WifiTxVector txAdapter;
+  txAdapter.SetChannelWidth (10);
+  // the DataRate set by higher layer is the minimum data rate
+  // which is the lower bound for the actual data rate.
+  if (txHigher.GetMode ().GetDataRate (txHigher.GetChannelWidth ()) > txMac.GetMode ().GetDataRate (txMac.GetChannelWidth ()))
+    {
+      txAdapter.SetMode (txHigher.GetMode ());
+      txAdapter.SetPreambleType (txHigher.GetPreambleType ());
+    }
+  else
+    {
+      txAdapter.SetMode (txMac.GetMode ());
+      txAdapter.SetPreambleType (txMac.GetPreambleType ());
+    }
+  // the TxPwr_Level set by higher layer is the maximum transmit
+  // power which is the upper bound for the actual transmit power;
+  txAdapter.SetTxPowerLevel (std::min (txHigher.GetTxPowerLevel (), txMac.GetTxPowerLevel ()));
+
+  return txAdapter;
+}
+
+bool
+WaveFrameExchangeManager::StartTransmission (Ptr<Txop> dcf)
+{
+  NS_LOG_FUNCTION (this << dcf);
+
+  uint32_t curChannel = m_phy->GetChannelNumber ();
+  // if current channel access is not AlternatingAccess, just do as FrameExchangeManager.
+  if (m_scheduler == 0 || !m_scheduler->IsAlternatingAccessAssigned (curChannel))
+    {
+      return FrameExchangeManager::StartTransmission (dcf);
+    }
+
+  m_txTimer.Cancel ();
+  m_dcf = dcf;
+
+  Ptr<WifiMacQueue> queue = dcf->GetWifiMacQueue ();
+
+  if (queue->IsEmpty ())
+    {
+      NS_LOG_DEBUG ("Queue empty");
+      m_dcf->NotifyChannelReleased ();
+      m_dcf = 0;
+      return false;
+    }
+
+  m_dcf->NotifyChannelAccessed ();
+  Ptr<WifiMacQueueItem> mpdu = *queue->Peek ()->GetQueueIteratorPairs ().front ().it;
+  NS_ASSERT (mpdu != 0);
+
+  // assign a sequence number if this is not a fragment nor a retransmission
+  if (!mpdu->IsFragment () && !mpdu->GetHeader ().IsRetry ())
+    {
+      uint16_t sequence = m_txMiddle->GetNextSequenceNumberFor (&mpdu->GetHeader ());
+      mpdu->GetHeader ().SetSequenceNumber (sequence);
+    }
+
+  WifiTxParameters txParams;
+  txParams.m_txVector = GetDataTxVector (mpdu);
+  Time remainingTime = m_coordinator->NeedTimeToGuardInterval ();
+
+  if (!TryAddMpdu (mpdu, txParams, remainingTime))
+    {
+      // The attempt for this transmission will be canceled;
+      // and this packet will be pending for next transmission by QosTxop class
+      NS_LOG_DEBUG ("Because the required transmission time exceeds the remainingTime = "
+                    << remainingTime.As (Time::MS)
+                    << ", currently this packet will not be transmitted.");
+    }
+  else
+    {
+      SendMpduWithProtection (mpdu, txParams);
+      return true;
+    }
+  return false;
+}
+
+void
+WaveFrameExchangeManager::DoDispose (void)
+{
+  NS_LOG_FUNCTION (this);
+  m_scheduler = 0;
+  m_coordinator = 0;
+  FrameExchangeManager::DoDispose ();
+}
+
+} //namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wave/model/wave-frame-exchange-manager.h ns-3.34/src/wave/model/wave-frame-exchange-manager.h
--- ns-3.33/src/wave/model/wave-frame-exchange-manager.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.34/src/wave/model/wave-frame-exchange-manager.h	2021-07-14 10:31:07.000000000 -0700
@@ -0,0 +1,87 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2020 Universita' degli Studi di Napoli Federico II
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Mathieu Lacage <mathieu.lacage@sophia.inria.fr>
+ *         Junling Bu <linlinjavaer@gmail.com>
+ *         Stefano Avallone <stavallo@unina.it>
+ */
+
+#ifndef WAVE_FRAME_EXCHANGE_MANAGER_H
+#define WAVE_FRAME_EXCHANGE_MANAGER_H
+
+#include "ns3/qos-frame-exchange-manager.h"
+#include "wave-net-device.h"
+
+namespace ns3 {
+
+/**
+ * \ingroup wave
+ *
+ * This class is the subclass of QosFrameExchangeManager to provide support for MAC extension
+ * (1) allows higher layer control data rate and tx power level.
+ *     If higher layer does not set, they will be determined by WifiRemoteStationManager
+ *          of MAC layer;
+ *     If higher layer sets tx parameters in non-adaptable mode, the data rate
+ *        and tx power level will be used for transmission;.
+ *    If higher layer sets tx parameters in adaptable mode, the data rate
+ *        will be lower bound for the actual data rate, and the power level
+ *        will be upper bound for the actual transmit power.
+ * (2) implements the feature described in Annex C : avoid transmission at scheduled guard intervals
+ *      However, the feature is extended further here that the required transmit time is determined
+ *      by MAC layer itself rather than PHY layer, which contains RTS/CTS, DATA and ACK time.
+ */
+class WaveFrameExchangeManager : public QosFrameExchangeManager
+{
+public:
+  /**
+   * \brief Get the type ID.
+   * \return the object TypeId
+   */
+  static TypeId GetTypeId (void);
+  WaveFrameExchangeManager ();
+  virtual ~WaveFrameExchangeManager ();
+
+  // Overridden from FrameExchangeManager
+  virtual bool StartTransmission (Ptr<Txop> dcf);
+
+  /**
+   * \param device WaveNetDevice associated with WaveFrameExchangeManager
+   */
+  void SetWaveNetDevice (Ptr<WaveNetDevice> device);
+
+protected:
+  // Overridden from FrameExchangeManager
+  virtual void DoDispose (void);
+
+private:
+  /**
+   * Return a TXVECTOR for the DATA frame given the destination.
+   * The function consults WifiRemoteStationManager, which controls the rate
+   * to different destinations.
+   *
+   * \param item the item being asked for TXVECTOR
+   * \return TXVECTOR for the given item
+   */
+  virtual WifiTxVector GetDataTxVector (Ptr<const WifiMacQueueItem> item) const;
+
+  Ptr<ChannelScheduler> m_scheduler;     ///< the channel scheduler
+  Ptr<ChannelCoordinator> m_coordinator; ///< the channel coordinator
+};
+
+} //namespace ns3
+
+#endif /* VHT_FRAME_EXCHANGE_MANAGER_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wave/model/wave-net-device.cc ns-3.34/src/wave/model/wave-net-device.cc
--- ns-3.33/src/wave/model/wave-net-device.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/wave/model/wave-net-device.cc	2021-07-14 10:31:07.000000000 -0700
@@ -117,6 +117,7 @@
       mac->Dispose ();
     }
   m_macEntities.clear ();
+  m_phyEntities.clear ();
   m_channelCoordinator->Dispose ();
   m_channelManager->Dispose ();
   m_channelScheduler->Dispose ();
@@ -126,7 +127,7 @@
   m_channelScheduler = 0;
   m_vsaManager = 0;
   // chain up.
-  NetDevice::DoDispose ();
+  WifiNetDevice::DoDispose ();
 }
 
 void
@@ -635,16 +636,6 @@
   return true;
 }
 
-Ptr<Node>
-WaveNetDevice::GetNode (void) const
-{
-  return m_node;
-}
-void
-WaveNetDevice::SetNode (Ptr<Node> node)
-{
-  m_node = node;
-}
 bool
 WaveNetDevice::NeedsArp (void) const
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wave/model/wave-net-device.h ns-3.34/src/wave/model/wave-net-device.h
--- ns-3.33/src/wave/model/wave-net-device.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/wave/model/wave-net-device.h	2021-07-14 10:31:07.000000000 -0700
@@ -343,8 +343,6 @@
   virtual Address GetMulticast (Ipv4Address multicastGroup) const;
   virtual bool IsPointToPoint (void) const;
   virtual bool IsBridge (void) const;
-  virtual Ptr<Node> GetNode (void) const;
-  virtual void SetNode (Ptr<Node> node);
   virtual bool NeedsArp (void) const;
   virtual void SetReceiveCallback (NetDevice::ReceiveCallback cb);
   virtual Address GetMulticast (Ipv6Address addr) const;
@@ -401,7 +399,6 @@
   TracedCallback<Address, Address> m_addressChange;
 
   // copy from WifiNetDevice
-  Ptr<Node> m_node; ///< the node
   NetDevice::ReceiveCallback m_forwardUp; ///< forward up receive callback
   NetDevice::PromiscReceiveCallback m_promiscRx; ///< promiscious receive callback
   uint32_t m_ifIndex; ///< IF index
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wave/test/examples-to-run.py ns-3.34/src/wave/test/examples-to-run.py
--- ns-3.33/src/wave/test/examples-to-run.py	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/wave/test/examples-to-run.py	2021-07-14 10:31:07.000000000 -0700
@@ -10,6 +10,9 @@
 cpp_examples = [
     ("wave-simple-80211p", "True", "True"),
     ("wave-simple-device", "True", "True"),
+    ("vanet-routing-compare --totaltime=2 --80211Mode=1", "True", "True"),
+    ("vanet-routing-compare --totaltime=2 --80211Mode=2", "True", "True"),
+    ("vanet-routing-compare --totaltime=2 --80211Mode=3", "True", "True"),
 ]
 
 # A list of Python examples to run in order to ensure that they remain
